Index: java/main/src/main/java/com/framsticks/structure/AbstractTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/structure/AbstractTree.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/structure/AbstractTree.java	(revision 105)
@@ -0,0 +1,345 @@
+package com.framsticks.structure;
+
+import java.util.Comparator;
+import java.util.Iterator;
+import java.util.Map;
+import java.util.PriorityQueue;
+
+import javax.annotation.Nonnull;
+
+import org.apache.commons.collections.map.ReferenceIdentityMap;
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.communication.queries.NeedFile;
+import com.framsticks.communication.queries.NeedFileAcceptor;
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ParamFlags;
+import com.framsticks.params.ParamsPackage;
+import com.framsticks.params.Registry;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.annotations.ParamAnnotation;
+import com.framsticks.structure.messages.ListChange;
+import com.framsticks.structure.messages.Message;
+import com.framsticks.structure.messages.Result;
+import com.framsticks.structure.messages.ValueChange;
+import com.framsticks.util.ExceptionHandler;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
+import com.framsticks.util.dispatching.AbstractJoinable;
+import com.framsticks.util.dispatching.BufferedDispatcher;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableParent;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.dispatching.ThrowExceptionHandler;
+import com.framsticks.util.lang.Pair;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@FramsClassAnnotation
+public abstract class AbstractTree extends AbstractJoinable implements Tree, JoinableParent, NeedFileAcceptor {
+
+	private static final Logger log = LogManager.getLogger(AbstractTree.class);
+
+	private Node root = null;
+	private ExceptionHandler handler = ThrowExceptionHandler.getInstance();
+
+	protected final BufferedDispatcher<Tree> bufferedDispatcher = new BufferedDispatcher<>(this);
+
+	protected final Registry registry = new Registry();
+
+	protected final PriorityQueue<Pair<Integer, NeedFileAcceptor>> needFileAcceptors = new PriorityQueue<>(32, new Comparator<Pair<Integer, NeedFileAcceptor>>() {
+
+		@Override
+		public int compare(Pair<Integer, NeedFileAcceptor> arg0, Pair<Integer, NeedFileAcceptor> arg1) {
+			if (arg0.first < arg1.first) {
+				return -1;
+			}
+			if (arg0.first > arg1.first) {
+				return 1;
+			}
+			return 0;
+		}
+	});
+
+	@Override
+	public void assignRootParam(CompositeParam param) {
+		if (root != null) {
+			throw new FramsticksException().msg("root has already specified type");
+		}
+		root = new Node(this, param, null);
+		log.debug("assigned root type: {}", root);
+	}
+
+	@Override
+	public void assignRootObject(Object object) {
+		if (root == null) {
+			throw new FramsticksException().msg("root has no type specified");
+		}
+		if (root.getObject() != null) {
+			throw new FramsticksException().msg("root has already object assigned").arg("current", root.getObject()).arg("candidate", object);
+		}
+		root = new Node(this, root.getParam(), object);
+		log.debug("assigned root object: {}", root);
+	}
+
+	@Override
+	public @Nonnull Node getAssignedRoot() {
+		if (root == null) {
+			throw new FramsticksException().msg("root has no type specified yet").arg("in", this);
+		}
+		return root;
+	}
+
+	public boolean isRootAssigned() {
+		// assert isActive();
+		return root != null;
+	}
+
+	protected String name;
+
+	public AbstractTree() {
+		setName("tree");
+
+		registry.registerAndBuild(Result.class);
+		registry.registerAndBuild(ValueChange.class);
+		registry.registerAndBuild(ListChange.class);
+		registry.registerAndBuild(Message.class);
+	}
+
+	protected void tryRegisterOnChangeEvents(Path path) {
+
+	}
+
+	@Override
+	public final FramsClass getInfoFromCache(String id) {
+		assert isActive();
+		return registry.getFramsClass(id);
+	}
+
+
+	@Override
+	public @Nonnull Access prepareAccess(CompositeParam param) {
+		return registry.prepareAccess(param);
+	}
+
+	@Override
+	public void takeAllFrom(Registry source) {
+		registry.takeAllFrom(source);
+	}
+
+	@AutoAppendAnnotation
+	public void usePackage(ParamsPackage paramsPackage) {
+		log.debug("using package {} in tree {}", paramsPackage, this);
+		paramsPackage.register(registry);
+	}
+
+	@AutoAppendAnnotation
+	public void takeFromRegistry(Registry registry) {
+		log.debug("taking from registry {} in tree {}", registry, this);
+		this.registry.takeAllFrom(registry);
+	}
+
+
+	@Override
+	public void putInfoIntoCache(FramsClass framclass) {
+		registry.putFramsClass(framclass);
+	}
+
+
+	/**
+	 * @return the handler
+	 */
+	@Override
+	public ExceptionHandler getExceptionHandler() {
+		return handler;
+	}
+
+	/**
+	 * @param handler the handler to set
+	 */
+	@Override
+	public void setExceptionHandler(ExceptionHandler handler) {
+		this.handler = handler;
+	}
+
+	@Override
+	public void handle(FramsticksException exception) {
+		handler.handle(exception);
+	}
+
+	/**
+	 * @return the dispatcher
+	 */
+	@Override
+	public Dispatcher<Tree> getDispatcher() {
+		return bufferedDispatcher;
+	}
+
+	/**
+	 * @param dispatcher the dispatcher to set
+	 */
+	@Override
+	public void setDispatcher(Dispatcher<Tree> dispatcher) {
+		bufferedDispatcher.setTargetDispatcher(dispatcher);
+	}
+
+	/**
+	 * @return the name
+	 */
+	@ParamAnnotation(flags = ParamFlags.USERREADONLY)
+	public String getName() {
+		return name;
+	}
+
+	/**
+	 * @param name the name to set
+	 */
+	@ParamAnnotation
+	public void setName(String name) {
+		this.name = name;
+	}
+
+	/**
+	 * @return the registry
+	 */
+	@Override
+	public Registry getRegistry() {
+		return registry;
+	}
+
+	@Override
+	protected void joinableStart() {
+		bufferedDispatcher.createThreadIfNeeded();
+		Dispatching.use(bufferedDispatcher, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(bufferedDispatcher, this);
+	}
+
+	@Override
+	protected void joinableFinish() {
+
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(bufferedDispatcher);
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		if (joinable == bufferedDispatcher) {
+			proceedToState(state);
+		}
+	}
+
+	@Override
+	public boolean isActive() {
+		return bufferedDispatcher.isActive();
+	}
+
+	@Override
+	public void dispatch(RunAt<? extends Tree> runnable) {
+		bufferedDispatcher.dispatch(runnable);
+	}
+
+
+	@SuppressWarnings("unchecked")
+	protected final Map<Object, Object> sideNotes = (Map<Object, Object>) new ReferenceIdentityMap(ReferenceIdentityMap.WEAK, ReferenceIdentityMap.HARD);
+
+	@Override
+	public <T> void putSideNote(Object object, SideNoteKey<T> key, T value) {
+		assert isActive();
+		Misc.throwIfNull(object);
+		Misc.throwIfNull(key);
+		Misc.throwIfNull(value);
+		Object sideNote = sideNotes.get(object);
+		if (sideNote == null) {
+			sideNote = new ReferenceIdentityMap(ReferenceIdentityMap.WEAK, ReferenceIdentityMap.HARD);
+			sideNotes.put(object, sideNote);
+		}
+		@SuppressWarnings("unchecked")
+		Map<SideNoteKey<?>, Object> sideNotesMap = (Map<SideNoteKey<?>, Object>) sideNote;
+		sideNotesMap.put(key, value);
+	}
+
+	@SuppressWarnings("unchecked")
+	@Override
+	public <T> T getSideNote(Object object, SideNoteKey<T> key) {
+		assert isActive();
+		Misc.throwIfNull(object);
+		Misc.throwIfNull(key);
+		Object sideNote = sideNotes.get(object);
+		if (sideNote == null) {
+			return null;
+		}
+		Object value = ((Map<SideNoteKey<?>, Object>) sideNote).get(key);
+		if (value == null) {
+			return null;
+		}
+		return (T) value;
+	}
+
+	@Override
+	public boolean removeSideNote(Object object, SideNoteKey<?> key) {
+		assert isActive();
+		Object sideNote = sideNotes.get(object);
+		if (sideNote == null) {
+			return false;
+		}
+		@SuppressWarnings("unchecked")
+		Map<SideNoteKey<?>, Object> sideNotesMap = (Map<SideNoteKey<?>, Object>) sideNote;
+		boolean result = (sideNotesMap.remove(key) != null);
+		if (sideNotesMap.isEmpty()) {
+			sideNotes.remove(object);
+		}
+		return result;
+	}
+
+	@Override
+	public void addNeedFileAcceptor(int priority, NeedFileAcceptor acceptor) {
+		assert isActive();
+		needFileAcceptors.add(Pair.make(priority, acceptor));
+	}
+
+	@Override
+	public void removeNeedFileAcceptor(NeedFileAcceptor acceptor) {
+		assert isActive();
+		Iterator<Pair<Integer, NeedFileAcceptor>> i = needFileAcceptors.iterator();
+		while (i.hasNext()) {
+			if (i.next().second == acceptor) {
+				i.remove();
+				break;
+			}
+		}
+	}
+
+	@Override
+	public boolean acceptNeed(final NeedFile needFile) {
+		Dispatching.dispatchIfNotActive(this, new RunAt<AbstractTree>(needFile.getFuture()) {
+
+			@Override
+			protected void runAt() {
+				for (Pair<Integer, NeedFileAcceptor> acceptor : needFileAcceptors) {
+					if (acceptor.second.acceptNeed(needFile)) {
+						return;
+					}
+				}
+				throw new FramsticksException().msg("failed to find need file acceptor in tree").arg("tree", AbstractTree.this).arg("needfile", needFile);
+			}
+		});
+		return true;
+	}
+
+}
+
Index: java/main/src/main/java/com/framsticks/structure/LocalTree.java
===================================================================
--- java/main/src/main/java/com/framsticks/structure/LocalTree.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/structure/LocalTree.java	(revision 105)
@@ -0,0 +1,194 @@
+package com.framsticks.structure;
+
+import org.apache.logging.log4j.Logger;
+import org.apache.logging.log4j.LogManager;
+
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.ParamBuilder;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.annotations.AutoAppendAnnotation;
+import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.DispatcherSetable;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Joinable;
+import com.framsticks.util.dispatching.JoinableState;
+import com.framsticks.util.lang.Casting;
+
+import static com.framsticks.structure.TreeOperations.*;
+
+@FramsClassAnnotation
+public final class LocalTree extends AbstractTree {
+	private static final Logger log = LogManager.getLogger(LocalTree.class);
+
+	protected Joinable joinableRootObject;
+
+	/**
+	 *
+	 */
+	public LocalTree() {
+		super();
+		bufferedDispatcher.setBuffer(false);
+	}
+
+	@SuppressWarnings({ "rawtypes", "unchecked" })
+	@AutoAppendAnnotation
+	public void setRootObject(Object object) {
+		final Class<?> javaClass = object.getClass();
+		registry.registerAndBuild(javaClass);
+
+		Access access = registry.createAccess(javaClass);
+
+		assignRootParam(access.buildParam(new ParamBuilder()).id(getName()).finish(CompositeParam.class));
+		assignRootObject(object);
+
+		if (object instanceof Joinable) {
+			joinableRootObject = (Joinable) object;
+		}
+		if (object instanceof DispatcherSetable) {
+			DispatcherSetable<?> setable = (DispatcherSetable<?>) object;
+			setable.setDispatcher((Dispatcher) this);
+		}
+	}
+
+	public Object getRootObject() {
+		Object result = getAssignedRoot().getObject();
+		if (result == null) {
+			throw new FramsticksException().msg("object tree is empty").arg("tree", this);
+		}
+		return result;
+	}
+
+	public <T> T getRootObject(Class<T> type) {
+		Object result = getRootObject();
+		if (!type.isInstance(result)) {
+			throw new FramsticksException().msg("object tree holds object of different kind").arg("object", result).arg("requested", type).arg("tree", this);
+		}
+		return type.cast(result);
+	}
+
+	@Override
+	public void get(Path path, FutureHandler<Path> future) {
+		assert isActive();
+		log.debug("requesting: {}", path);
+		path = resolveTopSync(path);
+		future.pass(path);
+	}
+
+	// @Override
+	// public void get(Path path, ValueParam param, Future<Object> future) {
+	//	assert isActive();
+	//	path = resolveTopSync(path);
+	//	future.pass(bindAccess(path).get(param, Object.class));
+	// }
+
+	@Override
+	public <R> void call(Path path, ProcedureParam param, Object[] arguments, Class<R> resultType, FutureHandler<R> future) {
+		assert isActive();
+		try {
+			Object result = bindAccess(path).call(param, arguments);
+			future.pass(Casting.nullOrThrowCast(resultType, result));
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	@Override
+	public void info(Path path, FutureHandler<FramsClass> future) {
+		assert isActive();
+		Path p = path.tryResolveIfNeeded();
+		Class<?> javaClass = p.getTopObject().getClass();
+		FramsClass framsClass = registry.registerReflectedIfNeeded(javaClass);
+		if (framsClass != null) {
+			future.pass(framsClass);
+		} else {
+			future.handle(new FramsticksException().msg("failed to find info for class").arg("java class", javaClass));
+		}
+	}
+
+	protected Path resolveTopSync(Path path) {
+		assert isActive();
+		assert path.isOwner(this);
+		if (path.getTop().getObject() != null) {
+			return path;
+		}
+		Access access = bindAccess(path.getUnder());
+		Object object = access.get(path.getTop().getParam(), Object.class);
+		if (object == null) {
+			throw new FramsticksException().msg("failed to resolve").arg("path", path);
+		}
+		return path.appendResolution(object);
+	}
+
+
+	@Override
+	public void set(Path path, PrimitiveParam<?> param, Object value, final FutureHandler<Integer> future) {
+		assert isActive();
+		future.pass(bindAccess(path).set(param, value));
+	}
+
+	public <A> void addListener(Path path, EventParam param, EventListener<A> listener, Class<A> argumentType, FutureHandler<Void> future) {
+		assert isActive();
+		try {
+			bindAccess(path).reg(param, listener);
+			future.pass(null);
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	public void removeListener(Path path, EventParam param, EventListener<?> listener, FutureHandler<Void> future) {
+		assert isActive();
+		try {
+			bindAccess(path).regRemove(param, listener);
+			future.pass(null);
+		} catch (FramsticksException e) {
+			future.handle(e);
+		}
+	}
+
+	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+		if (joinableRootObject != null) {
+			Dispatching.use(joinableRootObject, this);
+		}
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		if (joinableRootObject != null) {
+			Dispatching.drop(joinableRootObject, this);
+		}
+		super.joinableInterrupt();
+	}
+
+	@Override
+	protected void joinableFinish() {
+		super.joinableFinish();
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		if (joinableRootObject != null) {
+			Dispatching.join(joinableRootObject);
+		}
+		super.joinableJoin();
+	}
+
+	@Override
+	public void childChangedState(Joinable joinable, JoinableState state) {
+		super.childChangedState(joinable, state);
+		if (joinable == joinableRootObject) {
+			proceedToState(state);
+		}
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/structure/Node.java
===================================================================
--- java/main/src/main/java/com/framsticks/structure/Node.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/structure/Node.java	(revision 105)
@@ -0,0 +1,58 @@
+package com.framsticks.structure;
+
+import javax.annotation.Nonnull;
+import javax.annotation.concurrent.Immutable;
+
+import com.framsticks.params.CompositeParam;
+import com.framsticks.util.FramsticksException;
+// import com.framsticks.params.ParamBuilder;
+import com.framsticks.util.lang.Strings;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@Immutable
+public class Node {
+
+	protected final Tree tree;
+	protected final CompositeParam param;
+	protected final Object object;
+
+	public Node(Tree tree, @Nonnull CompositeParam param, Object object) {
+		assert param != null;
+		assert tree != null;
+		this.tree = tree;
+		this.param = param;
+		this.object = object;
+	}
+
+
+	public final Tree getTree() {
+		return tree;
+	}
+
+	public final CompositeParam getParam() {
+		return param;
+	}
+
+	public final Object getObject() {
+		return object;
+	}
+
+	@Override
+	public String toString() {
+		return param.toString() + ":" + Strings.toStringNullProof(object, "<null>");
+	}
+
+	public final boolean isResolved() {
+		return object != null;
+	}
+
+	public Node assureResolved() {
+		if (!isResolved()) {
+			throw new FramsticksException().msg("path is not resolved").arg("node", this);
+		}
+		return this;
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/structure/Path.java
===================================================================
--- java/main/src/main/java/com/framsticks/structure/Path.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/structure/Path.java	(revision 105)
@@ -0,0 +1,381 @@
+package com.framsticks.structure;
+
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.Param;
+import com.framsticks.params.ParamCollection;
+import com.framsticks.util.ExceptionHandler;
+import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.IgnoreExceptionHandler;
+import com.framsticks.util.lang.Pair;
+
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.regex.Pattern;
+
+import javax.annotation.Nonnull;
+import javax.annotation.concurrent.Immutable;
+
+import org.apache.commons.collections.ListUtils;
+
+/**
+ * @author Piotr Sniegowski
+ */
+@Immutable
+public final class Path implements ParamCollection {
+	// private final static Logger log = LogManager.getLogger(Path.class.getName());
+
+	final Tree tree;
+	final String textual;
+	final LinkedList<Node> nodes;
+
+	public static final SideNoteKey<CompositeParam> OBJECT_PARAM_KEY = SideNoteKey.make(CompositeParam.class);
+
+	protected static Object getKnownChild(Tree tree, Access access, CompositeParam param, ExceptionHandler handler) {
+		Object child = access.get(param, Object.class);
+		if (child == null) {
+			return null;
+		}
+		try {
+			tree.prepareAccess(param);
+			tree.putSideNote(child, OBJECT_PARAM_KEY, param);
+			return child;
+		} catch (FramsticksException e) {
+			handler.handle(e);
+		}
+		return null;
+	}
+
+	/**
+	 * @param tree
+	 * @param textual
+	 * @param nodes
+	 */
+	Path(Tree tree, String textual, LinkedList<Node> nodes) {
+		this.tree = tree;
+		this.textual = textual;
+		this.nodes = nodes;
+	}
+
+	public Path appendNode(Node node) {
+		assert isResolved();
+		return new PathBuilder().tree(tree).textual(textual + ((size() == 1) ? "" : "/") + node.getParam().getId()).add(nodes).add(node).finish();
+	}
+
+	public Path appendParam(CompositeParam param) {
+		assert isResolved();
+		return appendNode(new Node(tree, param, null));
+	}
+
+	public static class PathBuilder {
+
+		Tree tree;
+		String textual;
+		final LinkedList<Node> nodes = new LinkedList<Node>();
+
+		public Path finish() {
+			assert tree != null;
+			assert textual != null;
+			return new Path(tree, textual, nodes);
+		}
+
+		public PathBuilder()
+		{
+		}
+
+		public PathBuilder tree(Tree tree) {
+			this.tree = tree;
+			return this;
+		}
+
+		public PathBuilder textual(String textual) {
+			this.textual = textual;
+			return this;
+		}
+
+		public PathBuilder add(List<Node> nodes) {
+			this.nodes.addAll(nodes);
+			return this;
+		}
+
+		public PathBuilder add(Node node) {
+			this.nodes.add(node);
+			return this;
+		}
+
+		public PathBuilder setLast(Object object) {
+			Node n = nodes.pollLast();
+			nodes.add(new Node(n.getTree(), n.getParam(), object));
+			return this;
+		}
+
+		public PathBuilder buildUpTo(List<Node> nodes, Node node) {
+			StringBuilder b = new StringBuilder();
+			boolean add = false;
+			for (Node n : nodes) {
+				this.nodes.add(n);
+				if (add) {
+					b.append("/").append(n.getParam().getId());
+				}
+				add = true;
+				if (n == node) {
+					break;
+				}
+			}
+			this.textual = (nodes.size() == 1) ? "/" : b.toString();
+			return this;
+		}
+
+		public static Iterator<String> splitPath(String path) {
+			List<String> list = new LinkedList<String>();
+			for (String s : path.split("/")) {
+				if (!s.isEmpty()) {
+					list.add(s);
+				}
+			}
+			return list.iterator();
+		}
+
+		public PathBuilder resolve(@Nonnull Tree tree, String textual) {
+			return resolve(tree, textual, IgnoreExceptionHandler.getInstance());
+		}
+
+		public PathBuilder resolve(@Nonnull Tree tree, String textual, ExceptionHandler handler) {
+
+			assert nodes.isEmpty();
+			assert tree.isActive();
+			this.tree = tree;
+
+			Node current = tree.getAssignedRoot();
+			nodes.add(current);
+
+			StringBuilder b = new StringBuilder();
+			Iterator<String> i = splitPath(textual);
+			while (i.hasNext() && current.getObject() != null) {
+				Access access = TreeOperations.bindAccess(current);// tree.prepareAccess(current.getParam());
+				String e = i.next();
+				Param p = access.getParam(e);
+				if (p == null) {
+					break;
+				}
+				if (!(p instanceof CompositeParam)) {
+					throw new FramsticksException().msg("param is not a composite").arg("param", p).arg("tree", tree).arg("textual", textual).arg("access", access);
+				}
+				CompositeParam c = (CompositeParam) p;
+				b.append("/").append(e);
+				access.select(current.getObject());
+				tree.putSideNote(current.getObject(), OBJECT_PARAM_KEY, current.getParam());
+				current = new Node(current.getTree(), c, getKnownChild(tree, access, c, handler));
+				nodes.add(current);
+			}
+			this.textual = (nodes.size() == 1) ? "/" : b.toString();
+
+			return this;
+		}
+	}
+
+	public static PathBuilder build() {
+		return new PathBuilder();
+	}
+
+	public Path appendResolution(Object object) {
+		assert !isResolved();
+		Path result = new PathBuilder().textual(textual).tree(tree).add(nodes).setLast(object).finish();
+		assert size() == result.size();
+		return result;
+	}
+
+	public final Object getTopObject() {
+		return getTop().getObject();
+	}
+
+	public final Node getTop() {
+		return nodes.getLast();
+	}
+
+	public final Node getUnder() {
+		assert nodes.size() >= 2;
+		return nodes.get(nodes.size() - 2);
+	}
+
+	public final String getTextual() {
+		return textual;
+	}
+
+	public String toString() {
+		return tree + textual + (!isResolved() ? "!" : "");
+	}
+
+	public String getFullTextual() {
+		return tree.getName() + textual;
+	}
+
+	public final int size() {
+		assert Dispatching.isThreadSafe();
+		return nodes.size();
+	}
+
+	public final boolean isResolved() {
+		assert Dispatching.isThreadSafe();
+		return getTop().getObject() != null;
+	}
+
+	public final boolean isResolved(String textual) {
+		assert Dispatching.isThreadSafe();
+		return isTheSame(textual) && isResolved();
+	}
+
+	public final boolean isTheSame(String textual) {
+		assert Dispatching.isThreadSafe();
+		return this.textual.equals(textual);
+	}
+
+	public final boolean isTheSameTextually(Path path) {
+		assert Dispatching.isThreadSafe();
+		return (tree == path.getTree()) && textual.equals(path.getTextual());
+	}
+
+	public final @Nonnull Tree getTree() {
+		assert Dispatching.isThreadSafe();
+		return tree;
+	}
+
+	public Path tryResolveIfNeeded() {
+		if (isResolved()) {
+			return this;
+		}
+		return tryFindResolution();
+	}
+
+	/** Attach resolution at end, if available.
+	 *
+	 * @return Modified path, if resolution was available, this otherwise.
+	 */
+	public Path tryFindResolution() {
+		assert tree.isActive();
+		assert !isResolved();
+		if (size() == 1) {
+			return Path.build().resolve(tree, "/").finish();
+		}
+		Object child = getKnownChild(tree, TreeOperations.bindAccess(getUnder()), getTop().getParam(), IgnoreExceptionHandler.getInstance());
+		if (child == null) {
+			return this;
+		}
+		return appendResolution(child);
+	}
+
+
+	public String getLastElement() {
+		return getTop().getParam().getId();
+	}
+
+	public final boolean isOwner(Tree tree) {
+		return this.tree == tree;
+	}
+
+	@SuppressWarnings("unchecked")
+	public
+	List<Node> getNodes() {
+		return ListUtils.unmodifiableList(nodes);
+	}
+
+	public Path assureResolved() {
+		if (!isResolved()) {
+			throw new FramsticksException().msg("path is not resolved").arg("path", this);
+		}
+		return this;
+	}
+
+	public static Path tryTo(@Nonnull Tree tree, String textual) {
+		return Path.build().resolve(tree, textual).finish();
+	}
+
+	public static Path to(@Nonnull Tree tree, String textual) {
+		Path path = tryTo(tree, textual);
+		if (path.getTextual().equals(textual)) {
+			return path;
+		}
+		throw new FramsticksException().msg("failed to create path").arg("textual", textual).arg("result", path).arg("tree", tree);
+	}
+
+	public boolean isTheSameObjects(Path path) {
+		if (tree != path.getTree()) {
+			return false;
+		}
+		if (size() != path.size()) {
+			return false;
+		}
+		if (!getTextual().equals(path.getTextual())) {
+			return false;
+		}
+		Iterator<Node> a = nodes.iterator();
+		Iterator<Node> b = path.getNodes().iterator();
+		while (a.hasNext()) {
+			assert b.hasNext();
+			if (a.next() != b.next()) {
+				return false;
+			}
+		}
+		return true;
+	}
+
+	public static final Pattern pathPattern = Pattern.compile("(\\/)|((\\/[^/]+)+)");
+
+	public static boolean isValidString(String path) {
+		return pathPattern.matcher(path).matches();
+	}
+
+	public static String appendString(String path, String element) {
+		if (path.equals("/")) {
+			return path + element;
+		}
+		return path + "/" + element;
+	}
+
+	public static Pair<String, String> removeLastElement(String path) {
+		assert isValidString(path);
+		if (path.equals("/")) {
+			throw new FramsticksException().msg("cannot remove last element from root path");
+		}
+		int index = path.lastIndexOf('/');
+		assert index != -1;
+		if (index == 0) {
+			return new Pair<String, String>("/", path.substring(1));
+		}
+		return new Pair<String, String>(path.substring(0, index), path.substring(index + 1));
+	}
+
+	public static String validateString(String path) {
+		if (!isValidString(path)) {
+			throw new FramsticksException().msg("path string validation failured").arg("path", path);
+		}
+		return path;
+	}
+
+	@Override
+	public Param getParam(int i) {
+		return TreeOperations.getFramsClass(this).getParam(i);
+	}
+
+	@Override
+	public Param getParam(String id) {
+		return TreeOperations.getFramsClass(this).getParam(id);
+	}
+
+	@Override
+	public int getParamCount() {
+		return TreeOperations.getFramsClass(this).getParamCount();
+	}
+
+	@Override
+	public Iterable<Param> getParams() {
+		return TreeOperations.getFramsClass(this).getParams();
+	}
+	// public boolean isEmpty() {
+	//	return nodes.isEmpty();
+	// }
+
+}
+
Index: java/main/src/main/java/com/framsticks/structure/SideNoteKey.java
===================================================================
--- java/main/src/main/java/com/framsticks/structure/SideNoteKey.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/structure/SideNoteKey.java	(revision 105)
@@ -0,0 +1,28 @@
+package com.framsticks.structure;
+
+import com.framsticks.util.FramsticksException;
+
+public class SideNoteKey<T> {
+
+	protected final Class<T> type;
+
+	/**
+	 * @param type
+	 */
+	public SideNoteKey(Class<T> type) {
+		this.type = type;
+	}
+
+	public static <T2> SideNoteKey<T2> make(Class<T2> type) {
+		return new SideNoteKey<T2>(type);
+	}
+
+	public T newValue() {
+		try {
+			return type.newInstance();
+		} catch (InstantiationException | IllegalAccessException e) {
+			throw new FramsticksException().msg("failed to create side note value").arg("type", type).cause(e);
+		}
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/structure/Tree.java
===================================================================
--- java/main/src/main/java/com/framsticks/structure/Tree.java	(revision 105)
+++ java/main/src/main/java/com/framsticks/structure/Tree.java	(revision 105)
@@ -0,0 +1,77 @@
+package com.framsticks.structure;
+
+import javax.annotation.Nonnull;
+
+import com.framsticks.communication.queries.NeedFileAcceptor;
+import com.framsticks.params.Access;
+import com.framsticks.params.CompositeParam;
+import com.framsticks.params.EventListener;
+import com.framsticks.params.FramsClass;
+import com.framsticks.params.PrimitiveParam;
+import com.framsticks.params.Registry;
+import com.framsticks.params.types.EventParam;
+import com.framsticks.params.types.ProcedureParam;
+import com.framsticks.util.ExceptionHandler;
+import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.DispatcherSetable;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.Joinable;
+
+public interface Tree extends Dispatcher<Tree>, DispatcherSetable<Tree>, Joinable, ExceptionHandler {
+
+	public @Nonnull Node getAssignedRoot();
+	public void assignRootParam(CompositeParam param);
+	public void assignRootObject(Object object);
+
+	public @Nonnull Access prepareAccess(CompositeParam param);
+	public void takeAllFrom(Registry source);
+
+	public FramsClass getInfoFromCache(String id);
+
+	public void putInfoIntoCache(FramsClass framclass);
+
+	// /**
+	//  *
+	//  * Functions accepts ValueParam, because it is also possible to get number of List elements.
+	//  *
+	//  */
+	// public void get(Path path, ValueParam param, Future<Object> future);
+
+	public void get(Path path, FutureHandler<Path> future);
+
+	public <R> void call(Path path, ProcedureParam param, Object[] arguments, Class<R> resultType, FutureHandler<R> future);
+
+	/**
+	 *
+	 * Functions accepts PrimitiveParam<?>, because it is not possible to set number of List elements.
+	 *
+	 */
+	public void set(Path path, PrimitiveParam<?> param, Object value, FutureHandler<Integer> future);
+
+	public void info(Path path, FutureHandler<FramsClass> future);
+
+	public void setExceptionHandler(ExceptionHandler handler);
+
+	public ExceptionHandler getExceptionHandler();
+
+	// public void setDispatcher(Dispatcher<Tree> dispatcher);
+
+	// public Dispatcher<Tree> getDispatcher();
+
+	public <A> void addListener(Path path, EventParam param, EventListener<A> listener, Class<A> argumentType, FutureHandler<Void> future);
+
+	public void removeListener(Path path, EventParam param, EventListener<?> listener, FutureHandler<Void> future);
+
+	public Registry getRegistry();
+
+	public <T> void putSideNote(Object object, SideNoteKey<T> key, T value);
+
+	public <T> T getSideNote(Object object, SideNoteKey<T> key);
+
+	public boolean removeSideNote(Object object, SideNoteKey<?> key);
+
+	public void addNeedFileAcceptor(int priority, NeedFileAcceptor acceptor);
+
+	public void removeNeedFileAcceptor(NeedFileAcceptor acceptor);
+
+}
